## Créé le 11/9/2020 ##

######################################################
#  ___         __    __  ___         __   ___  ____  #
#  |__| |  |  /  \  /    |__| |  |  /  \  |__| |     #
#  |    |--| |    | ---- |    |--| |    | |\   |--   #
#  |    |  |  \__/  ___/ |    |  |  \__/  | \  |___  #
#                                                    #
######################################################


##
# Si aucune relation n'est spécifiée en argument, il s'agira d'un ajout de relation.
# Si une relations est passée en argument, il s'agira alors de l'éditer.
# Pour un ajout, spécifier uniquement les coordonnées.
# Pour une édition, indiquer en coordonnées 0:0 et passer son id
##
proc INTERFACE_ajout_relation {x y {id "null"}} {
    global relation_tmp
    global relations
    global tables
    global LOCALE
    global IMG
    #global id_attribut_graphique
    global E_nom_relation
    
    set liste_type_relations [list "0.1" "1.1" "0.n" "1.n" "n.n"]
    
    set f ".fen_ajout_relation"
    
    # Initialise la relation temporaire
    if {$id == "null"} {
        # Transfert des coordonnées
        set coords [list $x $y]
        set relation_tmp [Katyusha_Relations_init_relation]
        dict set relation_tmp "coords" $coords
        set E_nom_relation "Relation_[expr [dict size $relations] + 1]"
    } else {
        set relation [dict get $relations $id]
        set relation_tmp $relation
        set E_nom_relation [dict get $relation "nom"]
    }
    dict set relation_tmp "id" $id
    
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    
    # Frame de choix du nom de la table
    frame $f.nom
        label $f.nom.l -text "Nom de la relation : "
        entry $f.nom.e -textvariable E_nom_relation
        pack $f.nom.l $f.nom.e -side left
    pack $f.nom -pady 10 -padx 50
    
    ##
    # Liens de la relation
    ##
    frame $f.liens
        # Commandes des liens
        frame $f.liens.commandes
            # Bouton d'ajout d'un nouveau lien
            button $f.liens.commandes.ajout -text "+" -image $IMG(ajouter) -command {INTERFACE_ajout_lien_relation}
            # Bouton de supression d'un lien
            button $f.liens.commandes.supp -text "-" -image $IMG(supprimer) -command {INTERFACE_suppression_lien_relation}
            pack $f.liens.commandes.ajout $f.liens.commandes.supp -padx 10
        pack $f.liens.commandes -side left -fill x
        # Liste des liens
        frame $f.liens.liste
            label $f.liens.liste.titre -text "Liste des liens de la relation"
            pack $f.liens.liste.titre -fill x
            frame $f.liens.liste.tete
                label $f.liens.liste.tete.nom -text "Table concernée" -width 60 -height 2 -background white -relief solid
                label $f.liens.liste.tete.type -text "Type" -width 64 -height 2 -background white -relief solid
                pack $f.liens.liste.tete.nom $f.liens.liste.tete.type -fill x -side left
            pack $f.liens.liste.tete
            frame $f.liens.liste.corps
                ##
                # Ici viennent s'insérer les liens
                ##
                # Si la relation est en édition, on affiche la liste des liens déjà existants
                if {$id != "null"} {
                    set liens [dict get $relation "liens"]
                    foreach {k lien} $liens {
                        frame $f.liens.liste.corps.$k
                            label $f.liens.liste.corps.$k.table -text [lindex $lien 0] -width 60 -height 2 -background white -relief solid
                            label $f.liens.liste.corps.$k.type -text [lindex $lien 1] -width 60 -height 2 -background white -relief solid
                            button $f.liens.liste.corps.$k.edit -text "Éditer" -image $IMG(editer) -command "INTERFACE_ajout_lien_relation $k"
                            pack $f.liens.liste.corps.$k.table $f.liens.liste.corps.$k.type $f.liens.liste.corps.$k.edit -side left
                        pack $f.liens.liste.corps.$k
                    }
                }
                # TODO
            pack $f.liens.liste.corps -fill x
        pack $f.liens.liste -fill x
    pack $f.liens -fill x -padx 10
    
    ##
    # Attributs de la relation
    ##
    frame $f.attributs
        # Commandes des attributs
        frame $f.attributs.commandes
            # Bouton d'ajout d'un nouvel attribut
            button $f.attributs.commandes.ajout -text "+" -image $IMG(ajouter) -command {INTERFACE_ajout_attribut "relation"}
            # Bouton de supression d'un nouvel attribut
            button $f.attributs.commandes.supp -text "-" -image $IMG(supprimer) -command {INTERFACE_suppression_attribut "relation"}
            pack $f.attributs.commandes.ajout $f.attributs.commandes.supp -padx 10
        pack $f.attributs.commandes -side left -fill x
        # Liste des attributs
        frame $f.attributs.liste
            label $f.attributs.titre -text "Liste des attributs de la relation"
            pack $f.attributs.titre -fill x
            frame $f.attributs.tete
                label $f.attributs.tete.nom -text "Nom" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.type -text "Type" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.taille -text "Taille" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.valeur -text "Valeur par défaut" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.auto -text "Incrément?" -width 20 -height 2 -background white -relief solid
                label $f.attributs.tete.pk -text "Clef primaire?" -width 20 -height 2 -background white -relief solid
                pack $f.attributs.tete.nom $f.attributs.tete.type $f.attributs.tete.taille $f.attributs.tete.valeur $f.attributs.tete.auto $f.attributs.tete.pk -fill x -side left
            pack $f.attributs.tete -fill x
            frame $f.attributs.corps
                ##
                # Ici viennent s'insérer les attributs
                ##
                # Si la relation est en édition, on affiche la liste des attributs déjà existants
                if {$id != "null"} {
                    set attributs [dict get $relation "attributs"]
                    foreach {id_attribut_graphique attribut} $attributs {
                        frame $f.attributs.corps.$id_attribut_graphique
                            label $f.attributs.corps.$id_attribut_graphique.nom -text [dict get $attribut "nom"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$id_attribut_graphique.type -text [dict get $attribut "type"] -width 20 -height 2 -height 2 -background white -relief solid
                            label $f.attributs.corps.$id_attribut_graphique.taille -text [dict get $attribut "taille"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$id_attribut_graphique.valeur -text [dict get $attribut "valeur"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$id_attribut_graphique.auto -text [dict get $attribut "auto"] -width 20 -height 2 -background white -relief solid
                            label $f.attributs.corps.$id_attribut_graphique.pk -text [dict get $attribut "pk"] -width 20 -height 2 -background white -relief solid
                            button $f.attributs.corps.$id_attribut_graphique.edit -text "Éditer" -image $IMG(editer) -command "Katyusha_Relations_modification_attribut $id_attribut_graphique"
                            pack $f.attributs.corps.$id_attribut_graphique.nom $f.attributs.corps.$id_attribut_graphique.type $f.attributs.corps.$id_attribut_graphique.taille $f.attributs.corps.$id_attribut_graphique.valeur $f.attributs.corps.$id_attribut_graphique.auto $f.attributs.corps.$id_attribut_graphique.pk -side left
                        pack $f.attributs.corps.$id_attribut_graphique -fill x
                    }
                }
            pack $f.attributs.corps -fill x
        pack $f.attributs.liste -side left -fill x
    pack $f.attributs -fill x -padx 10
    
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left -command {
            global relation_tmp
            set f ".fen_ajout_relation"
            set id [dict get $relation_tmp "id"]
            dict set relation_tmp "nom" [$f.nom.e get]
            dict set relation_tmp "description" ""
            set ok [Katyusha_Relations_controle_relation $relation_tmp]
            if {$id == "null" && $ok == 1} {
                Katyusha_ajout_relation $relation_tmp
                destroy $f
            } elseif {$id != "null" && $ok == 1} {
                Katyusha_Relations_modification_relation $id $relation_tmp
                destroy $f
            }
        }
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command {
            if {[winfo exists .fen_ajout_attribut]} {
                destroy .fen_ajout_attribut
            }
            destroy .fen_ajout_relation
        }
        pack $f.commandes.ok -side left -fill x -pady 10 -padx 50
        pack $f.commandes.ko -side right -fill x -pady 10 -padx 50
    pack $f.commandes -fill x
    
    # Titre le la présente fenêtre
    if {$id == "null"} {
        wm title $f "Ajouter une relation"
    } else {
        wm title $f "Éditer la relation : $E_nom_relation"
    }
    
    # Mise à jour forcée de l'affichage graphique
    update
}

##
# Fenêtre d'ajout de lien à une relation
##
proc INTERFACE_ajout_lien_relation {{id_lien "null"}} {
    global relation_tmp
    global tables
    global IMG
    global LOCALE
    
    set f ".fen_ajout_lien_relation"
    
    set liste_type_relations [list "0.1" "1.1" "0.n" "1.n" "n.n"]
    
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    # Créé la fenêtre
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    # Choix des tables concernées par la relation
    frame $f.tables
        label $f.tables.info -text "Sélectionner la table concernée par le lien :"
        pack $f.tables.info
        frame $f.tables.tete
            label $f.tables.tete.ct -text "Table" -width 20
            label $f.tables.tete.cr -text "Type de lien" -width 20
            pack $f.tables.tete.ct $f.tables.tete.cr -side left
        pack $f.tables.tete -fill x
        frame $f.tables.r
            ttk::combobox $f.tables.r.ct -values [liste_tables] -width 20
            ttk::combobox $f.tables.r.cr -values $liste_type_relations -width 20
            pack $f.tables.r.ct $f.tables.r.cr -side left
        pack $f.tables.r -fill x
        # Si il y a moins de deux tables, avertir l'utilisateur
        if {[dict size $tables] < 1} {
            label $f.tables.info_err -text "Il n'y a pas assez de tables dans le MCD." -justify left -foreground red
            pack $f.tables.info_err
        }
    pack $f.tables -pady 10 -padx 20
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left -command "INTERFACE_COMMANDE_ajout_lien $id_lien"
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command "destroy $f"
        pack $f.commandes.ok -side left -fill x -pady 10 -padx 50
        pack $f.commandes.ko -side right -fill x -pady 10 -padx 50
    pack $f.commandes -fill x
}

proc INTERFACE_COMMANDE_ajout_lien {id_lien} {
    global relation_tmp
    
    set f ".fen_ajout_lien_relation"
    
    if {$id_lien == "null"} {
        Katyusha_Relations_ajout_lien [$f.tables.r.ct get] [$f.tables.r.cr get]
    } else {
        Katyusha_Relations_modification_lien $id_lien [$f.tables.r.ct get] [$f.tables.r.cr get]
    }
    destroy $f
}

proc INTERFACE_suppression_lien_relation {} {
    global relation_tmp
    global LOCALE
    global IMG
    
    set f ".fen_supp_lien_relation"
    set liens [list]
    
    # Détruit la fenêtre si elle existe déjà
    if {[winfo exists $f]} {
        destroy $f
    }
    toplevel $f
    # Icone de la fenêtre
    wm iconphoto $f $IMG(logo)
    
    foreach {k lien} [dict get $relation_tmp "liens"] {
        lappend liens "$k : $lien"
    }
    
    # Frame de titre
    frame $f.nom
        label $f.nom.l -text "Sélectionner un lien à supprimer"
        pack $f.nom.l -fill x
    pack $f.nom -fill x -pady 10 -padx 50
    ttk::combobox $f.cb -value $liens -width 50
    pack $f.cb
    frame $f.commandes
        button $f.commandes.ok -text $LOCALE(valider) -image $IMG(valider) -compound left -command {
            global relation_tmp
            
            set f ".fen_supp_lien_relation"
            set lien [$f.cb get]
            if {$lien == ""} {
                set rep [tk_messageBox -message "Sélectionner un lien à supprimmer"]
            } else {
                set id_lien [lindex [split $lien " : "] 0]
                set liens [dict get $relation_tmp "liens"]
                dict unset liens $id_lien
                dict set relation_tmp "liens" $liens
            }
            destroy .fen_ajout_relation.liens.liste.corps.$id_lien
            destroy $f
        }
        button $f.commandes.ko -text $LOCALE(retour) -image $IMG(retour) -compound left -command {destroy .fen_supp_lien_relation}
        pack $f.commandes.ok -side left -fill x -pady 10 -padx 50
        pack $f.commandes.ko -side right -fill x -pady 10 -padx 50
    pack $f.commandes
    
    # Titre le la présente fenêtre
    wm title $f "Supprimer un lien"
    update
}
