## Créé le 22/6/2020 ##

######################################################
#  ___         __    __  ___         __   ___  ____  #
#  |__| |  |  /  \  /    |__| |  |  /  \  |__| |     #
#  |    |--| |    | ---- |    |--| |    | |\   |--   #
#  |    |  |  \__/  ___/ |    |  |  \__/  | \  |___  #
#                                                    #
######################################################

# Répertoire racine du script
set rpr [file dirname [info script]]
# Répertoire racine de l'exécutable
#set rpr [file dirname [file normalize [info nameofexecutable]]]


source "$rpr/fonctions_interface.tcl"
source "$rpr/C/Images.tcl"
source "$rpr/C/Splash.tcl"
source "$rpr/C/INTERFACE_Entites.tcl"
source "$rpr/C/INTERFACE_Etiquettes.tcl"
source "$rpr/C/INTERFACE_Tables.tcl"
source "$rpr/C/INTERFACE_Relations.tcl"
source "$rpr/C/INTERFACE_Heritages.tcl"
source "$rpr/C/C.tcl"
source "$rpr/C/SQL_gen.tcl"
source "$rpr/C/XML.tcl"
source "$rpr/C/sauvegarde_charge.tcl"
source "$rpr/C/entites.tcl"
source "$rpr/C/Configurations.tcl"
source "$rpr/C/verification_mcd.tcl"
source "$rpr/C/Interface.tcl"
source "$rpr/C/SQL.tcl"
source "$rpr/C/Relations.tcl"
source "$rpr/C/Etiquettes.tcl"
source "$rpr/C/Tables.tcl"
source "$rpr/C/Sauvegarde.tcl"
source "$rpr/C/Charge.tcl"
source "$rpr/C/MCD.tcl"
source "$rpr/C/Heritages.tcl"
source "$rpr/C/Attributs.tcl"

#set theme awbreeze
#source "$rpr/Themes/colorutils.tcl"
#source "$rpr/Themes/awthemes.tcl"
#source "$rpr/Themes/$theme.tcl"

# Tk
puts -nonewline "Chargement de Tk"
if {[catch {package require Tk}]} {
    puts " # TK obligatoire pour ce programme!"
    exit
} else {
    puts " # OK!"
}

#ttk::style theme use breeze
#set tbg [ttk::style lookup TFrame -background]
#lassign [winfo rgb . $tbg] bg_r bg_g bg_b
#. configure -background $tbg

Katyusha_Images

# Splash
set CONFIGS(RESOLUTION) "auto"
Katyusha_Splash $rpr

puts "Initialisation........"

# Configurations
puts "Chargement des configurations"
set rep_configs "~/.phosphore/katyusha_mcd"
Katyusha_Configurations_init

array set CONFIG {}
array set MCD {}
Katyusha_Configurations_charge $rpr $rep_configs

# Répertoire par défaut des projets Katyusha MCD
set id_projet -1

Katyusha_MCD_init

set version 0.1.0
set splash [lindex [list "Катюша!" "Katyusha!" "کاتیوشا" "Катюша!"] [expr int((rand() * 4) + 1) - 1]]
set sgbd 0
# Fichier dans lequel toutes les sauvegardes simples se feronts
set fichier_sauvegarde ""
# Action du bouton Gauche de la souris
set ACTION_B1 "null"

set zoom_compteur 0


# Initialisation de la traduction
puts "Chargement de la langue locale"
# Par défaut, français
if {![file exists "$rpr/locale/$CONFIGS(LANG).tcl"]} {
    source "$rpr/locale/fr.tcl"
} else {
    source "$rpr/locale/$CONFIGS(LANG).tcl"
}


Katyusha_Configurations_packages

puts "v$version"

puts "OK!"

set OS [lindex $tcl_platform(os) 0]
puts "OS : $OS"

after 1000

Katyusha_Interface
source "$rpr/C/bind.tcl"
